import pprocess
import time

N = 10
limit = 10

def make_array(n):
    return [list(x) for x in [(0,) * n] * n]

def calculate(ch, i, j):
    time.sleep(1)
    ch.send((i, j, i * N + j))

def wait(exchange, D):
    print "Processes:", len(exchange.active())
    while len(exchange.active()) >= limit:
        store(exchange, D)

def store(exchange, D):
    for ch in exchange.ready():
        i, j, result = ch.receive()
        D[i][j] = result

if __name__ == "__main__":
    D = make_array(N)
    exchange = pprocess.Exchange()

    print "Calculating..."
    for i in range(0, N):
        for j in range(0, N):
            ch = pprocess.start(calculate, i, j)
            wait(exchange, D)
            exchange.add(ch)

    print "Finishing..."
    while exchange.active():
        store(exchange, D)

    print
    for row in D:
        print row

# vim: tabstop=4 expandtab shiftwidth=4
